/***************************************************************************
 *                                                                         *
 *   Copyright (C) 2005  Nicolas AGIUS                                     *
 *                                                                         *
 *   This file is part of ECaMM.                                           *
 *                                                                         *
 *   ECaMM is free software; you can redistribute it and/or modify it      *
 *   under the terms of the GNU General Public License as published by     *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 *                                                                         *
 *   ECaMM is distributed in the hope that it will be useful, but          *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston,                *
 *    MA  02111-1307, USA.                                                 *
 *                                                                         *
 *   For more information about these matters, see the file named COPYING. *
 *                                                                         *
 *   Mail : nicolas_agius@yahoo.fr                                         *
 *                                                                         *
 ***************************************************************************/
package ecamm;

/**
 * Titre :  CommuneDATA [ECaMM]
 * Description : Classe de donnes communes
 * Copyright : GPL v2.0 - 2005
 * @author : Nicolas AGIUS
 * @version 1.0
 */

import java.sql.SQLException;
import java.sql.ResultSet;

public class CommuneDATA extends Data
{
    private CircoDATA m_dCirco;
    private String m_sNom;
    private String m_sPostal;

    public CommuneDATA()
    {
        p_iID=NONE;
        m_dCirco=new CircoDATA();
        m_sNom="";
        m_sPostal="";
    }

    public CommuneDATA(ResultSet rs) throws SQLException
    {
        p_iID=rs.getInt("CO_ID");
        m_sNom=rs.getString("CO_NOM");
        m_sPostal=rs.getString("CO_POSTAL");
	m_dCirco=new CircoDATA(rs);
    }

    public String getNom()
    {
        return m_sNom;
    }

    public String getPostal()
    {
        return m_sPostal;
    }

    public CircoDATA getCirco()
    {
        return m_dCirco;
    }

    public String toString()
    {
        return m_sNom;
    }
}
