/***************************************************************************
 *                                                                         *
 *   Copyright (C) 2005  Nicolas AGIUS                                     *
 *                                                                         *
 *   This file is part of ECaMM.                                           *
 *                                                                         *
 *   ECaMM is free software; you can redistribute it and/or modify it      *
 *   under the terms of the GNU General Public License as published by     *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 *                                                                         *
 *   ECaMM is distributed in the hope that it will be useful, but          *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston,                *
 *    MA  02111-1307, USA.                                                 *
 *                                                                         *
 *   For more information about these matters, see the file named COPYING. *
 *                                                                         *
 *   Mail : nicolas_agius@yahoo.fr                                         *
 *                                                                         *
 ***************************************************************************/
package ecamm;

/**
 * Titre :  ContactDATA [ECaMM]
 * Description : Classe de donnes Contacts
 * Copyright : GPL v2.0 - 2005
 * @author : Nicolas AGIUS
 * @version 1.0
 */

import java.sql.SQLException;
import java.sql.ResultSet;


public class ContactDATA extends Data
{
    private String m_sNom;
    private String m_sPrenom;
    private String m_sMail;
    private String m_sTelW;
    private String m_sTelP;
    private String m_sOrga;
    private CircoDATA m_dCirco;

    public ContactDATA()
    {
        //initialisation  vide
        p_iID=NONE;
        m_sNom="";
        m_sPrenom="";
        m_sMail="";
        m_sTelW="";
        m_sTelP="";
        m_sOrga="";
        m_dCirco=new CircoDATA();
    }

    public ContactDATA(ResultSet rs) throws SQLException
    {
        //initialisation avec les donnes du resultset
        p_iID=rs.getInt("CT_ID");
        m_sNom=rs.getString("CT_NOM");
        m_sPrenom=rs.getString("CT_PRENOM");
        m_sMail=rs.getString("CT_MAIL");
        m_sTelW=rs.getString("CT_TELW");
        m_sTelP=rs.getString("CT_TELP");
        m_sOrga=rs.getString("CT_ORGA");
	m_dCirco=new CircoDATA(rs);
    }

    public CircoDATA getCirco()
    {
        return m_dCirco;
    }

    public String getNom()
    {
        return m_sNom;
    }

    public String getPrenom()
    {
        return m_sPrenom;
    }

    public String getMail()
    {
        return m_sMail;
    }

    public String getTelW()
    {
        return m_sTelW;
    }

    public String getTelP()
    {
        return m_sTelP;
    }

    public String getOrga()
    {
        return m_sOrga;
    }

    public String getFiche()
    {
	return new String(    "Nom :    \t" + m_sPrenom +" " + m_sNom
			  + "\nE-mail :\t" + m_sMail
			  + "\nTlphone :\t" + m_sTelW
			  + "\nPortable :\t" + m_sTelP
			  + "\nOrgnisation :\t" + m_sOrga
			  + "\nCirconscription: " + m_dCirco);
    }

    public String toString()
    {
        return m_sPrenom + " " + m_sNom + ", " + m_dCirco;
    }

}
