/***************************************************************************
 *                                                                         *
 *   Copyright (C) 2005  Nicolas AGIUS                                     *
 *                                                                         *
 *   This file is part of ECaMM.                                           *
 *                                                                         *
 *   ECaMM is free software; you can redistribute it and/or modify it      *
 *   under the terms of the GNU General Public License as published by     *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 *                                                                         *
 *   ECaMM is distributed in the hope that it will be useful, but          *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston,                *
 *    MA  02111-1307, USA.                                                 *
 *                                                                         *
 *   For more information about these matters, see the file named COPYING. *
 *                                                                         *
 *   Mail : nicolas_agius@yahoo.fr                                         *
 *                                                                         *
 ***************************************************************************/
package ecamm;

/**
 * Titre :  CreerIHM [ECaMM]
 * Description : Fentre de cration d'une demande
 * Copyright : GPL v2.0 - 2005~2006
 * @author : Nicolas AGIUS
 * @version 2.0
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.undo.*;
import javax.swing.border.*;
import javax.swing.text.DefaultEditorKit;
import java.awt.datatransfer.DataFlavor;

public class CreerIHM extends JFrame
{
    //hauteur des popups list contact et etab
    private static final int POPUP_HEIGHT=110;

    //constantes pour l'IHM
    private static final String CARD_DATEAUTO="auto-date";
    private static final String CARD_DATESELECT="select-date";

    //Constantes pour le keybinding
    private static final String ACTION_SAVE="save";
    private static final String ACTION_CANCEL="cancel";
    private static final String ACTION_NEWET="new-etablissement";
    private static final String ACTION_NEWCT="new-contact";
    private static final String ACTION_FOCUSCT="contact-focus";
    private static final String ACTION_FOCUSET="etab-focus";
    private static final String ACTION_FOCUSSOL="sol-focus";
    private static final String ACTION_FOCUSPROB="prob-focus";
    private static final String ACTION_ETOK="popup-etab-ok";
    private static final String ACTION_ETCANCEL="popup-etab-cancel";
    private static final String ACTION_CTOK="popup-contact-ok";
    private static final String ACTION_CTCANCEL="popup-contact-cancel";
    private static final String ACTION_DELET="delete-etab";
    private static final String ACTION_DELCT="delete-conatct";
    private static final String ACTION_UNDOPROB="undo-prob";
    private static final String ACTION_REDOPROB="redo-prob";
    private static final String ACTION_UNDOSOL="undo-sol";
    private static final String ACTION_REDOSOL="redo-sol";

    //variable de traitement
    private ConfigurationCTL cf=Main.cf;
    private AjouterContactIHM m_ihmAddContact;
    private AjouterEtabIHM m_ihmAddEtab;
    private RechercherCTL m_ctlRechercher;
    private AjouterCTL m_ctlAjouter;
    private Vector m_vEtabs=new Vector();
    private Vector m_vContacts=new Vector();
    private boolean m_bDateAuto = true;

    //composant graphiques
    private JPanel jPanel1 = new JPanel();
    private JLabel jLabel1 = new JLabel();
    private JLabel jLabel2 = new JLabel();
    private JLabel jLabel5 = new JLabel();
    private JLabel jLabelDay = new JLabel();
    private JLabel jLabelToday = new JLabel();
    private JSpinner jSpinnerDate = new JSpinner();
    private JScrollPane jScrollPane1 = new JScrollPane();
    private JScrollPane jScrollPaneSol = new JScrollPane();
    private JTextArea jTextAreaProb = new JTextArea();
    private JTextArea jTextAreaSol = new JTextArea();
    private JLabel jLabel3 = new JLabel();
    private ButtonGroup buttonGroupType = new ButtonGroup();
    private JPanel jPanelType = new JPanel();
    private JRadioButton jRadioButtonTypeMail = new JRadioButton();
    private JRadioButton jRadioButtonTypeTel = new JRadioButton();
    private JRadioButton jRadioButtonTypeDirect = new JRadioButton();
    private JRadioButton jRadioButtonTypeAuto = new JRadioButton();
    private GridLayout gridLayout1 = new GridLayout();
    private JPanel jPanelDate = new JPanel();
    private JPanel jPanel3 = new JPanel();
    private JPanel jPanelDateSelect = new JPanel();
    private JPanel jPanelDateAuto = new JPanel();
    private JButton jButtonSave = new JButton();
    private JButton jButtonCancel = new JButton();
    private JButton jButtonDateSelect = new JButton();
    private JButton jButtonDateAuto = new JButton();
    private JPanel jPanelEtab = new JPanel();
    private TitledBorder titledBorder1;
    private JButton jButtonAddEtab = new JButton();
    private JTextField jTextFieldEtab = new JTextField();
    private JScrollPane jScrollPane3 = new JScrollPane();
    private JList jListEtab = new JList();
    private JScrollPane jScrollPaneFindEtab = new JScrollPane();
    private JList jListFindEtab = new JList();
    private JPanel jPanelContact = new JPanel();
    private TitledBorder titledBorder2;
    private JList jListFindContact = new JList();
    private JButton jButtonAddContact = new JButton();
    private JScrollPane jScrollPaneFindContact = new JScrollPane();
    private JTextField jTextFieldContact = new JTextField();
    private JScrollPane jScrollPane6 = new JScrollPane();
    private JList jListContact = new JList();
    private JLabel jLabel4 = new JLabel();
    private JPanel jPanelPri = new JPanel();
    private GridLayout gridLayout2 = new GridLayout();
    private JRadioButton jRadioButtonPrioHigh = new JRadioButton();
    private JRadioButton jRadioButtonPrioNorm = new JRadioButton();
    private JRadioButton jRadioButtonPrioLow = new JRadioButton();
    private ButtonGroup buttonGroupPri = new ButtonGroup();
    private GridBagLayout gridBagLayout1 = new GridBagLayout();
    private GridBagLayout gridBagLayout2 = new GridBagLayout();
    private GridBagLayout gridBagLayout3 = new GridBagLayout();
    private GridBagLayout gridBagLayout4 = new GridBagLayout();
    private CardLayout cardLayoutDate = new CardLayout();
    private JPanel jPanelFindEtab = new JPanel();
    private JPanel jPanelFindContact = new JPanel();
    private JLayeredPane layeredPane;
    private UndoManager undoManagerProb = new UndoManager();
    private JPopupMenu jPopupMenuProb = new JPopupMenu();
    private JMenuItem jMenuItemUndoProb = new JMenuItem();
    private JMenuItem jMenuItemRedoProb = new JMenuItem();
    private JMenuItem jMenuItemPasteProb;
    private JMenuItem jMenuItemCutProb;
    private JMenuItem jMenuItemCopyProb;
    private UndoManager undoManagerSol = new UndoManager();
    private JPopupMenu jPopupMenuSol = new JPopupMenu();
    private JMenuItem jMenuItemUndoSol = new JMenuItem();
    private JMenuItem jMenuItemRedoSol = new JMenuItem();
    private JMenuItem jMenuItemPasteSol;
    private JMenuItem jMenuItemCutSol;
    private JMenuItem jMenuItemCopySol;

    public CreerIHM(AjouterContactIHM ihmAddContact, AjouterEtabIHM ihmAddEtab)
    {
        cf.registerIHM(this);
        setSize(cf.getCreerSize());
        setLocation(cf.getCreerLocation());
        m_ihmAddContact=ihmAddContact;
        m_ihmAddEtab=ihmAddEtab;

        //Classe de controle mutualise
        m_ctlRechercher=cf.getRechercherCTL();
        m_ctlAjouter=cf.getAjouterCTL();


        try
        {
            popupMenuInit();
            jbInit();
            keyBindingInit();
            popupInit();
        }
        catch(Exception e)
        {
            Tools.internalError(e,"",cf.debug(),true);
        }
    }

    private void jbInit() throws Exception
    {
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(134, 134, 134)),"Etablissement :");
        titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(134, 134, 134)),"Contact : ");
        jLabel1.setText("Problme :");
        jLabel2.setText("Remarque :");
        jPanel1.setLayout(gridBagLayout1);
        jLabel3.setText("Type :");
        jPanelType.setLayout(gridLayout1);
        jRadioButtonTypeMail.setText("E-mail");
        jRadioButtonTypeMail.setMnemonic('e');
        jRadioButtonTypeMail.setActionCommand("1");
        jRadioButtonTypeTel.setSelected(true);
        jRadioButtonTypeTel.setText("Tlphone");
        jRadioButtonTypeTel.setMnemonic('t');
        jRadioButtonTypeTel.setActionCommand("2");
        jRadioButtonTypeDirect.setText("Direct");
        jRadioButtonTypeDirect.setMnemonic('d');
        jRadioButtonTypeDirect.setActionCommand("3");
        jRadioButtonTypeAuto.setText("Automatique");
        jRadioButtonTypeAuto.setMnemonic('a');
        jRadioButtonTypeAuto.setActionCommand("4");
        gridLayout1.setRows(4);
        gridLayout1.setColumns(1);
        jButtonDateSelect.setText("Diffrer");
        jButtonDateSelect.setMargin(new Insets(0, 2, 0, 2));
        jButtonDateSelect.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonDateSelect_actionPerformed(e);
            }
        });
        jButtonDateAuto.setText("Auto");
        jButtonDateAuto.setMargin(new Insets(0, 2, 0, 2));
        jButtonDateAuto.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonDateAuto_actionPerformed(e);
            }
        });
        jPanelDate.setLayout(cardLayoutDate);
        jPanelDate.add(jPanelDateAuto,CARD_DATEAUTO);
        jPanelDate.add(jPanelDateSelect,CARD_DATESELECT);
        jSpinnerDate.setModel(new SpinnerDateModel());
	jSpinnerDate.setEditor(new JSpinner.DateEditor(jSpinnerDate, "dd/MM/yyyy"));
        jSpinnerDate.addChangeListener(new ChangeListener()
        {
            public void stateChanged(ChangeEvent e)
            {
                jSpinnerDate_stateChanged(e);
            }
        });
        jLabel5.setText("Demande datant du");
        jLabelToday.setText("");
        jPanelDateSelect.setLayout(gridBagLayout4);
        jPanelDateSelect.add(jLabel5, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 6, 0, 0), 0, 0));
        jPanelDateSelect.add(jLabelDay, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 0, 0, 0), 0, 0));
        jPanelDateSelect.add(jSpinnerDate, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 6, 0, 0), 0, 0));
        jPanelDateSelect.add(jLabelToday, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 12, 0, 0), 0, 0));
        jPanelDateSelect.add(jButtonDateAuto, new GridBagConstraints(4, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(3, 0, 0, 6), 0, 0));

        jPanelDateAuto.setLayout(new FlowLayout(FlowLayout.TRAILING,6,3));
        jPanelDateAuto.add(jButtonDateSelect);
        jButtonSave.setText("Enregistrer");
        jButtonSave.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonSave_actionPerformed(e);
            }
        });
        jButtonCancel.setText("Annuler");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonCancel_actionPerformed(e);
            }
        });
        this.setTitle("Nouvelle demande");
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        this.addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                this_windowClosing(e);
            }
        });
        jTextAreaProb.setWrapStyleWord(true);
        jTextAreaProb.setLineWrap(true);
        jTextAreaProb.getDocument().addUndoableEditListener(new UndoableEditListener()
        {
            public void undoableEditHappened(UndoableEditEvent e)
            {
                undoManagerProb.addEdit(e.getEdit());
            }
        });
        jTextAreaSol.setWrapStyleWord(true);
        jTextAreaSol.setLineWrap(true);
        jTextAreaSol.getDocument().addUndoableEditListener(new UndoableEditListener()
        {
            public void undoableEditHappened(UndoableEditEvent e)
            {
                undoManagerSol.addEdit(e.getEdit());
            }
        });
        jPanelEtab.setBorder(titledBorder1);
        jPanelEtab.setMinimumSize(new Dimension(83, 110));
        jPanelEtab.setPreferredSize(new Dimension(83, 110));
        jPanelEtab.setLayout(gridBagLayout2);
        jButtonAddEtab.setMargin(new Insets(0, 2, 0, 2));
        jButtonAddEtab.setText("Nouveau");
        jButtonAddEtab.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonAddEtab_actionPerformed(e);
            }
        });
        jTextFieldEtab.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jTextFieldEtab_actionPerformed(e);
            }
        });
        jTextFieldEtab.addMouseListener(new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                jTextFieldEtab_mouseClicked(e);
            }
        });
        jScrollPaneFindEtab.setBounds(new Rectangle(10, 48, 329, 33));
        jPanelContact.setBorder(titledBorder2);
        jPanelContact.setMinimumSize(new Dimension(83, 110));
        jPanelContact.setPreferredSize(new Dimension(83, 110));
        jPanelContact.setLayout(gridBagLayout3);
        jButtonAddContact.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonAddContact_actionPerformed(e);
            }
        });
        jButtonAddContact.setText("Nouveau");
        jButtonAddContact.setMargin(new Insets(0, 2, 0, 2));
        jScrollPaneFindContact.setBounds(new Rectangle(12, 45, 438, 33));
        jTextFieldContact.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jTextFieldContact_actionPerformed(e);
            }
        });
        jTextFieldContact.addMouseListener(new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                jTextFieldContact_mouseClicked(e);
            }
        });
        jLabel4.setText("Priorit :");
        jPanelPri.setLayout(gridLayout2);
        gridLayout2.setRows(3);
        gridLayout2.setColumns(1);
        jRadioButtonPrioHigh.setText("Haute");
        jRadioButtonPrioHigh.setMnemonic('h');
        jRadioButtonPrioHigh.setActionCommand("1");
        jRadioButtonPrioNorm.setSelected(true);
        jRadioButtonPrioNorm.setText("Normale");
        jRadioButtonPrioNorm.setMnemonic('n');
        jRadioButtonPrioNorm.setActionCommand("2");
        jRadioButtonPrioLow.setText("Basse");
        jRadioButtonPrioLow.setMnemonic('b');
        jRadioButtonPrioLow.setActionCommand("3");
        jListFindEtab.addMouseListener(new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                jListFindEtab_mouseClicked(e);
            }
        });
        jListFindEtab.addFocusListener(new FocusAdapter()
        {
            public void focusLost(FocusEvent e)
            {
                jListFindEtab_focusLost(e);
            }
        });
        jListFindContact.addMouseListener(new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                jListFindContact_mouseClicked(e);
            }
        });
        jListFindContact.addFocusListener(new FocusAdapter()
        {
            public void focusLost(FocusEvent e)
            {
                jListFindContact_focusLost(e);
            }
        });
        buttonGroupType.add(jRadioButtonTypeMail);
        buttonGroupType.add(jRadioButtonTypeTel);
        buttonGroupType.add(jRadioButtonTypeDirect);
        buttonGroupType.add(jRadioButtonTypeAuto);
        buttonGroupPri.add(jRadioButtonPrioHigh);
        buttonGroupPri.add(jRadioButtonPrioNorm);
        buttonGroupPri.add(jRadioButtonPrioLow);
        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanelEtab.add(jButtonAddEtab, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 3, 0, 3), 0, 0));
        jPanelEtab.add(jTextFieldEtab, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 3, 0, 0), 0, 0));
        jPanelEtab.add(jScrollPane3, new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0
            ,GridBagConstraints.NORTH, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));
        jPanel1.add(jPanelDate, new GridBagConstraints(0, 0, 3, 1, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        jPanel1.add(jLabel3, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 6, 0, 0), 0, 0));
        jPanel1.add(jPanelType, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(3, 20, 0, 10), 0, -20));
        jPanel1.add(jPanelEtab, new GridBagConstraints(1, 1, 2, 2, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 0));
        jPanelType.add(jRadioButtonTypeMail, null);
        jPanelType.add(jRadioButtonTypeTel, null);
        jPanelType.add(jRadioButtonTypeDirect, null);
        jPanelType.add(jRadioButtonTypeAuto, null);
        jPanel1.add(jPanelContact, new GridBagConstraints(0, 3, 3, 1, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(0, 6, 0, 6), 0, 0));
        jPanelContact.add(jTextFieldContact, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 3, 0, 0), 0, 0));
        jPanelContact.add(jButtonAddContact, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 3, 0, 3), 0, 0));
        jPanelContact.add(jScrollPane6, new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));
        jPanel1.add(jLabel1, new GridBagConstraints(0, 4, 3, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 0, 6), 0, 0));
        jPanel1.add(jScrollPane1, new GridBagConstraints(0, 5, 3, 1, 1.0, 1.0
            ,GridBagConstraints.NORTH, GridBagConstraints.BOTH, new Insets(3, 12, 0, 12), 0, 0));
        jPanel1.add(jLabel2, new GridBagConstraints(0, 6, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 0, 0), 0, 0));
        jPanel1.add(jLabel4, new GridBagConstraints(2, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 0, 6), 0, 0));
        jPanel1.add(jScrollPaneSol, new GridBagConstraints(0, 7, 2, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(3, 12, 0, 0), 0, 0));
        jPanel1.add(jPanelPri, new GridBagConstraints(2, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(3, 20, 0, 12), 0, 0));
        jPanelPri.add(jRadioButtonPrioHigh, null);
        jPanelPri.add(jRadioButtonPrioNorm, null);
        jPanelPri.add(jRadioButtonPrioLow, null);
        jPanel1.add(jPanel3, new GridBagConstraints(0, 8, 3, 1, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(6, 0, 6, 0), 0, 0));
        jPanel3.add(jButtonSave, null);
        jPanel3.add(jButtonCancel, null);
        jScrollPaneSol.getViewport().add(jTextAreaSol, null);
        jScrollPane1.getViewport().add(jTextAreaProb, null);
        jScrollPane6.getViewport().add(jListContact, null);
        jScrollPaneFindContact.getViewport().add(jListFindContact, null);
        jScrollPane3.getViewport().add(jListEtab, null);
        jScrollPaneFindEtab.getViewport().add(jListFindEtab, null);
        this.addComponentListener(new ComponentAdapter()
        {
          public void componentResized(ComponentEvent e)
          {
            this_componentResized(e);
          }
        });
        jListEtab.addMouseListener(new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                jListEtab_mouseClicked(e);
            }
        });
        jListContact.addMouseListener(new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                jListContact_mouseClicked(e);
            }
        });
    }

    private void popupInit() throws Exception
    {
        //ajout des popups
        jPanelFindEtab.setLayout(new BorderLayout());
        jPanelFindContact.setLayout(new BorderLayout());
        jListFindEtab.setBackground(new Color(255,255,153));
        jListFindContact.setBackground(new Color(255,255,153));
        jPanelFindEtab.add(jScrollPaneFindEtab,BorderLayout.CENTER);
        jPanelFindContact.add(jScrollPaneFindContact,BorderLayout.CENTER);
        layeredPane=this.getLayeredPane();
        layeredPane.add(jPanelFindEtab,JLayeredPane.POPUP_LAYER);
        layeredPane.add(jPanelFindContact,JLayeredPane.POPUP_LAYER);
        jPanelFindEtab.setVisible(false);
        jPanelFindContact.setVisible(false);
    }

    private void keyBindingInit() throws Exception
    {
        //Keys binding gnraux
        InputMap inputMap=jPanel1.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);
        ActionMap actionMap=jPanel1.getActionMap();
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0),ACTION_SAVE);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_F10,0),ACTION_SAVE);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE,0),ACTION_CANCEL);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_F9,0),ACTION_NEWCT);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_F8,0),ACTION_NEWET);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_R,ActionEvent.CTRL_MASK),ACTION_FOCUSSOL);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_P,ActionEvent.CTRL_MASK),ACTION_FOCUSPROB);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_E,ActionEvent.CTRL_MASK),ACTION_FOCUSET);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_O,ActionEvent.CTRL_MASK),ACTION_FOCUSCT);
        actionMap.put(ACTION_SAVE,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonSave_actionPerformed(e);
            }
        });
        actionMap.put(ACTION_CANCEL,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
		if(confirmCancel())
                    jButtonCancel_actionPerformed(e);
            }
        });
        actionMap.put(ACTION_NEWCT,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonAddContact_actionPerformed(e);
            }
        });
        actionMap.put(ACTION_NEWET,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jButtonAddEtab_actionPerformed(e);
            }
        });
        actionMap.put(ACTION_FOCUSCT,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jTextFieldContact.requestFocusInWindow();
            }
        });
        actionMap.put(ACTION_FOCUSET,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jTextFieldEtab.requestFocusInWindow();
            }
        });
        actionMap.put(ACTION_FOCUSPROB,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jTextAreaProb.requestFocusInWindow();
            }
        });
        actionMap.put(ACTION_FOCUSSOL,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jTextAreaSol.requestFocusInWindow();
            }
        });

        //Keybinding popups
        jPanelFindEtab.getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0),ACTION_ETOK);
        jPanelFindEtab.getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE,0),ACTION_ETCANCEL);
        jPanelFindEtab.getActionMap().put(ACTION_ETOK,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jListFindEtab_actionPerformed(null);
            }
        });
        jPanelFindEtab.getActionMap().put(ACTION_ETCANCEL,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jListFindEtab_focusLost(null);
                jTextFieldEtab.requestFocusInWindow();
            }
        });
        jPanelFindContact.getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0),ACTION_CTOK);
        jPanelFindContact.getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE,0),ACTION_CTCANCEL);
        jPanelFindContact.getActionMap().put(ACTION_CTOK,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jListFindContact_actionPerformed(null);
            }
        });
        jPanelFindContact.getActionMap().put(ACTION_CTCANCEL,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jListFindContact_focusLost(null);
                jTextFieldContact.requestFocusInWindow();
            }
        });

        //Keybinding list
        jListEtab.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE,0),ACTION_DELET);
        jListEtab.getActionMap().put(ACTION_DELET,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jListEtab_actionPerformed(e);
            }
        });
        jListContact.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE,0),ACTION_DELCT);
        jListContact.getActionMap().put(ACTION_DELCT,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jListContact_actionPerformed(e);
            }
        });

        //Keybinding textArea undo/redo
        jTextAreaProb.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_Z,ActionEvent.CTRL_MASK),ACTION_UNDOPROB);
        jTextAreaProb.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_Y,ActionEvent.CTRL_MASK),ACTION_REDOPROB);
        jTextAreaProb.getActionMap().put(ACTION_UNDOPROB,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
               jMenuItemUndoProb_actionPerformed(e);
            }
        });
        jTextAreaProb.getActionMap().put(ACTION_REDOPROB,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItemRedoProb_actionPerformed(e);
            }
        });
        jTextAreaSol.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_Z,ActionEvent.CTRL_MASK),ACTION_UNDOSOL);
        jTextAreaSol.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_Y,ActionEvent.CTRL_MASK),ACTION_REDOSOL);
        jTextAreaSol.getActionMap().put(ACTION_UNDOSOL,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
               jMenuItemUndoSol_actionPerformed(e);
            }
        });
        jTextAreaSol.getActionMap().put(ACTION_REDOSOL,new AbstractAction()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItemRedoSol_actionPerformed(e);
            }
        });
    }

    private void popupMenuInit() throws Exception
    {
        //Cration de la hashmap des actions de jTextAreaProb
        HashMap hmProb = new HashMap();
        Action[] a = jTextAreaProb.getActions();
        for(int i=0; i<a.length; hmProb.put(a[i].getValue(Action.NAME), a[i++]));

        //Cration de la hashmap des actions de jTextAreaSol
        HashMap hmSol = new HashMap();
        Action[] b = jTextAreaSol.getActions();
        for(int i=0; i<b.length; hmSol.put(b[i].getValue(Action.NAME), b[i++]));

        //cration du menu popup prob
        jMenuItemUndoProb.setText("Annuler");
        jMenuItemUndoProb.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItemUndoProb_actionPerformed(e);
            }
        });

        jMenuItemRedoProb.setText("Rtablir");
        jMenuItemRedoProb.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItemRedoProb_actionPerformed(e);
            }
        });

        jPopupMenuProb.add(jMenuItemUndoProb);
        jPopupMenuProb.add(jMenuItemRedoProb);
        jPopupMenuProb.addSeparator();

        //ajout des actions prdfinies dans le menu prob
        jMenuItemCutProb=jPopupMenuProb.add((Action)hmProb.get(DefaultEditorKit.cutAction));
        jMenuItemCutProb.setText("Couper");
        jMenuItemCopyProb=jPopupMenuProb.add((Action)hmProb.get(DefaultEditorKit.copyAction));
        jMenuItemCopyProb.setText("Copier");
        jMenuItemPasteProb=jPopupMenuProb.add((Action)hmProb.get(DefaultEditorKit.pasteAction));
        jMenuItemPasteProb.setText("Coller");
        jPopupMenuProb.addSeparator();
        jPopupMenuProb.add((Action)hmProb.get(DefaultEditorKit.selectAllAction)).setText("Slectionner tout");

        //cration du menu popup sol
        jMenuItemUndoSol.setText("Annuler");
        jMenuItemUndoSol.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItemUndoSol_actionPerformed(e);
            }
        });

        jMenuItemRedoSol.setText("Rtablir");
        jMenuItemRedoSol.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItemRedoSol_actionPerformed(e);
            }
        });

        jPopupMenuSol.add(jMenuItemUndoSol);
        jPopupMenuSol.add(jMenuItemRedoSol);
        jPopupMenuSol.addSeparator();

        //ajout des actions prdfinies dans le menu sol
        jMenuItemCutSol=jPopupMenuSol.add((Action)hmSol.get(DefaultEditorKit.cutAction));
        jMenuItemCutSol.setText("Couper");
        jMenuItemCopySol=jPopupMenuSol.add((Action)hmSol.get(DefaultEditorKit.copyAction));
        jMenuItemCopySol.setText("Copier");
        jMenuItemPasteSol=jPopupMenuSol.add((Action)hmSol.get(DefaultEditorKit.pasteAction));
        jMenuItemPasteSol.setText("Coller");
        jPopupMenuSol.addSeparator();
        jPopupMenuSol.add((Action)hmSol.get(DefaultEditorKit.selectAllAction)).setText("Slectionner tout");

        //ouverture du popup prob
        jTextAreaProb.addMouseListener(new MouseAdapter()
        {
            public void mousePressed(MouseEvent e)
            {
                maybeShowPopup(e);
            }

            public void mouseReleased(MouseEvent e)
            {
                maybeShowPopup(e);
            }

            private void maybeShowPopup(MouseEvent e)
            {
                if(e.isPopupTrigger())
                {
                    //activation de "coller" si texte prsent dans le presse papier
                    try
                    {
                        String st = (String)Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null).getTransferData(DataFlavor.stringFlavor);
                        jMenuItemPasteProb.setEnabled(st.length()>0);
                    }
                    catch(Exception ex)
                    {
                        jMenuItemPasteProb.setEnabled(false);
                    }

                    //activation de "couper" "copier" si texte slectionn
                    boolean textSelected = jTextAreaProb.getSelectedText()!=null;
                    jMenuItemCopyProb.setEnabled(textSelected);
                    jMenuItemCutProb.setEnabled(textSelected);

                    //activation de "annuler" "refaire" si possible
                    jMenuItemUndoProb.setEnabled(undoManagerProb.canUndo());
                    jMenuItemRedoProb.setEnabled(undoManagerProb.canRedo());

                    jTextAreaProb.requestFocus();
                    jPopupMenuProb.show(e.getComponent(),e.getX(), e.getY());
                }
            }
        });

        //ouverture du popup sol
        jTextAreaSol.addMouseListener(new MouseAdapter()
        {
            public void mousePressed(MouseEvent e)
            {
                maybeShowPopup(e);
            }

            public void mouseReleased(MouseEvent e)
            {
                maybeShowPopup(e);
            }

            private void maybeShowPopup(MouseEvent e)
            {
                if(e.isPopupTrigger())
                {
                    //activation de "coller" si texte prsent dans le presse papier
                    try
                    {
                        String st = (String)Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null).getTransferData(DataFlavor.stringFlavor);
                        jMenuItemPasteSol.setEnabled(st.length()>0);
                    }
                    catch(Exception ex)
                    {
                        jMenuItemPasteSol.setEnabled(false);
                    }

                    //activation de "couper" "copier" si texte slectionn
                    boolean textSelected = jTextAreaSol.getSelectedText()!=null;
                    jMenuItemCopySol.setEnabled(textSelected);
                    jMenuItemCutSol.setEnabled(textSelected);

                    //activation de "annuler" "refaire" si possible
                    jMenuItemUndoSol.setEnabled(undoManagerSol.canUndo());
                    jMenuItemRedoSol.setEnabled(undoManagerSol.canRedo());

                    jTextAreaSol.requestFocus();
                    jPopupMenuSol.show(e.getComponent(),e.getX(), e.getY());
                }
            }
        });
    }

    //pop-up de confirmation d'enregistrement
    private boolean confirm()
    {
       return JOptionPane.showConfirmDialog(this,"Etes vous sr de vouloir enregistrer\nces donnes ?",
		       "Confirmation de mise  jour",JOptionPane.YES_NO_OPTION,
		       JOptionPane.WARNING_MESSAGE)==JOptionPane.YES_OPTION;
    }

    //pop-up de confirmation d'annulation
    private boolean confirmCancel()
    {
       return JOptionPane.showConfirmDialog(this,"Etes vous sr de vouloir annuler sans enregistrer ?",
		       "Confirmation d'annulation",JOptionPane.YES_NO_OPTION,
		       JOptionPane.WARNING_MESSAGE)==JOptionPane.YES_OPTION;
    }

    private void addContact(ContactDATA ct)
    {
        if(!m_vContacts.contains(ct)) //gestion des doublons
        {
            m_vContacts.add(ct);
            jListContact.setListData(m_vContacts);
        }
    }

    private void addEtab(EtabDATA et)
    {
        if(!m_vEtabs.contains(et)) //gestion des doublons
        {
            m_vEtabs.add(et);
            jListEtab.setListData(m_vEtabs);
        }
    }

    public void notifyNewContact()
    {
        addContact(m_ctlRechercher.getLastNewContact());
    }

    public void notifyNewEtab()
    {
        addEtab(m_ctlRechercher.getLastNewEtab());
    }

    //vide les champs de saisie
    void jButtonCancel_actionPerformed(ActionEvent e)
    {
        jTextFieldContact.setText("");
        jTextFieldEtab.setText("");
        jListFindContact.setListData(new Vector());
        jListFindEtab.setListData(new Vector());
        m_vContacts.clear();
        m_vEtabs.clear();
        jTextAreaProb.setText("");
        jTextAreaSol.setText("");

        //flush des tampons undo
        undoManagerProb.discardAllEdits();
        undoManagerSol.discardAllEdits();

        jRadioButtonPrioNorm.setSelected(true);
        jRadioButtonTypeTel.setSelected(true);
        jPanelFindEtab.setVisible(false);
        jPanelFindContact.setVisible(false);
        jButtonDateAuto_actionPerformed(null);
        this.setVisible(false);
    }

    void jButtonAddEtab_actionPerformed(ActionEvent e)
    {
        m_ihmAddEtab.setVisible(this);
    }

    void jButtonAddContact_actionPerformed(ActionEvent e)
    {
        m_ihmAddContact.setVisible(this);
    }

    void jTextFieldEtab_actionPerformed(ActionEvent e)
    {
        //recherche dynamique de l'etablissement
        jListFindEtab.setListData(m_ctlRechercher.getEtabs(jTextFieldEtab.getText()));

        //Affichage du popup
        jListFindEtab.setSelectedIndex(0);
        jPanelFindEtab.setVisible(true);
        jListFindEtab.requestFocusInWindow();
    }

    void jListFindEtab_mouseClicked(MouseEvent e)
    {
        if(e.getClickCount()==1 && SwingUtilities.isLeftMouseButton(e))
            jListFindEtab_actionPerformed(null);
    }

    void jListFindEtab_actionPerformed(ActionEvent e)
    {
        if(!jListFindEtab.isSelectionEmpty())
        {
            addEtab((EtabDATA)jListFindEtab.getSelectedValue());
        }

        //fermeture du popup
        jPanelFindEtab.setVisible(false);
        jTextFieldEtab.requestFocusInWindow();
    }

    void jTextFieldEtab_mouseClicked(MouseEvent e)
    {
        if(e.getClickCount()==2 || e.getClickCount()==1 && SwingUtilities.isRightMouseButton(e))
        {
            jTextFieldEtab_actionPerformed(null);
        }
    }

    void jTextFieldContact_mouseClicked(MouseEvent e)
    {
        if(e.getClickCount()==2 || e.getClickCount()==1 && SwingUtilities.isRightMouseButton(e))
        {
            jTextFieldContact_actionPerformed(null);
        }
    }

    void jTextFieldContact_actionPerformed(ActionEvent e)
    {
        //recherche dynamique de l'etablissement
        jListFindContact.setListData(m_ctlRechercher.getContacts(jTextFieldContact.getText()));

        //affichage du popup
        jListFindContact.setSelectedIndex(0);
        jPanelFindContact.setVisible(true);
        jListFindContact.requestFocusInWindow();
    }

    void jListFindContact_mouseClicked(MouseEvent e)
    {
        if(e.getClickCount()==1 && SwingUtilities.isLeftMouseButton(e))
            jListFindContact_actionPerformed(null);
    }

    void jListFindContact_actionPerformed(ActionEvent e)
    {
        if(!jListFindContact.isSelectionEmpty())
        {
            addContact((ContactDATA)jListFindContact.getSelectedValue());
        }

        //fermeture du popup
        jPanelFindContact.setVisible(false);
        jTextFieldContact.requestFocusInWindow();
    }

    void jButtonSave_actionPerformed(ActionEvent e)
    {
        //controle des champs obligatoires
        int type=Integer.parseInt(buttonGroupType.getSelection().getActionCommand());
        int pri=Integer.parseInt(buttonGroupPri.getSelection().getActionCommand());
        String prob=jTextAreaProb.getText();
        Date date=(Date)jSpinnerDate.getValue();

        if(prob.length()<=0)
        {
            JOptionPane.showMessageDialog(this,"Vous devez saisir le problme.",
               "Erreur de saisie",JOptionPane.ERROR_MESSAGE);
            return;
        }

        if(!m_bDateAuto) //si date en manuel
        {
            Date serverDate=m_ctlRechercher.getServerDate();

            //si date dans le futur
            if(date.after(serverDate))
            {
                JOptionPane.showMessageDialog(this,"Date dans le futur interdite.",
                   "Erreur de saisie",JOptionPane.ERROR_MESSAGE);
                return;
            }

            //si date inchange
            if(serverDate.equals(date))
                m_bDateAuto = true; //repassage en automatique (pour avoir l'heure)
        }

        if(confirm())
        {
            if(m_ctlAjouter.addDemande(prob,jTextAreaSol.getText(),type,pri,
                                       m_vEtabs,m_vContacts,
                                       m_bDateAuto,date))
            {
                //vidage et fermeture de la fentre
                jButtonCancel_actionPerformed(null);
            }
        }
    }

    void this_componentResized(ComponentEvent e)
    {
        //positionnement du popup Etablissement
        Rectangle dimE=jTextFieldEtab.getBounds();
        Rectangle panelE=jPanelEtab.getBounds();
        jPanelFindEtab.setBounds(dimE.x+panelE.x,dimE.y+dimE.height+panelE.y,dimE.width,POPUP_HEIGHT);

        //positionnement du popup Contact
        Rectangle dimC=jTextFieldContact.getBounds();
        Rectangle panelC=jPanelContact.getBounds();
        jPanelFindContact.setBounds(dimC.x+panelC.x,dimC.y+dimC.height+panelC.y,dimC.width,POPUP_HEIGHT);
    }

    public void setVisible(boolean b)
    {
        //interception de l'affichage pour
        //lancement a retardement du calcul de la position des popups
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                this_componentResized(null);
            }
        });
        super.setVisible(b);
        jTextFieldEtab.requestFocusInWindow();
    }

    void this_windowClosing(WindowEvent e)
    {
        jButtonCancel_actionPerformed(null);
    }

    void jListFindEtab_focusLost(FocusEvent e)
    {
        jPanelFindEtab.setVisible(false);
    }

    void jListFindContact_focusLost(FocusEvent e)
    {
        jPanelFindContact.setVisible(false);
    }

    //supression d'un lment de la liste
    void jListContact_actionPerformed(ActionEvent e)
    {
        if(!jListContact.isSelectionEmpty())
        {
            m_vContacts.removeElement(jListContact.getSelectedValue());
            jListContact.setListData(m_vContacts);
        }
    }

    //supression d'un lment de la liste
    void jListEtab_actionPerformed(ActionEvent e)
    {
        if(!jListEtab.isSelectionEmpty())
        {
            m_vEtabs.removeElement(jListEtab.getSelectedValue());
            jListEtab.setListData(m_vEtabs);
        }
    }

    void jListEtab_mouseClicked(MouseEvent e)
    {
        if(SwingUtilities.isRightMouseButton(e) && e.getClickCount()==2)
            jListEtab_actionPerformed(null);
    }

    void jListContact_mouseClicked(MouseEvent e)
    {
        if(SwingUtilities.isRightMouseButton(e) && e.getClickCount()==2)
            jListContact_actionPerformed(null);
    }

    void jButtonDateSelect_actionPerformed(ActionEvent e)
    {
        m_bDateAuto=false;
        cardLayoutDate.show(jPanelDate,CARD_DATESELECT);

        Date serverDate=m_ctlRechercher.getServerDate();
        jSpinnerDate.setValue(serverDate);
    }

    void jButtonDateAuto_actionPerformed(ActionEvent e)
    {
        m_bDateAuto=true;
        cardLayoutDate.show(jPanelDate,CARD_DATEAUTO);
    }

    void jMenuItemUndoProb_actionPerformed(ActionEvent e)
    {
        try
        {
            undoManagerProb.undo();
        }
        catch (CannotUndoException ex) {}
    }

    void jMenuItemRedoProb_actionPerformed(ActionEvent e)
    {
        try
        {
            undoManagerProb.redo();
        }
        catch(CannotRedoException ex) {}
    }

    void jMenuItemUndoSol_actionPerformed(ActionEvent e)
    {
        try
        {
            undoManagerSol.undo();
        }
        catch (CannotUndoException ex) {}
    }

    void jMenuItemRedoSol_actionPerformed(ActionEvent e)
    {
        try
        {
            undoManagerSol.redo();
        }
        catch(CannotRedoException ex) {}
    }

    void jSpinnerDate_stateChanged(ChangeEvent e)
    {
        GregorianCalendar cal = new GregorianCalendar();
        cal.setTime((Date)jSpinnerDate.getValue());
        jLabelDay.setText("  (" + Tools.dayOfWeek(cal.get(Calendar.DAY_OF_WEEK)) + ")");
    }
}
