/***************************************************************************
 *                                                                         *
 *   Copyright (C) 2005  Nicolas AGIUS                                     *
 *                                                                         *
 *   This file is part of ECaMM.                                           *
 *                                                                         *
 *   ECaMM is free software; you can redistribute it and/or modify it      *
 *   under the terms of the GNU General Public License as published by     *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 *                                                                         *
 *   ECaMM is distributed in the hope that it will be useful, but          *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston,                *
 *    MA  02111-1307, USA.                                                 *
 *                                                                         *
 *   For more information about these matters, see the file named COPYING. *
 *                                                                         *
 *   Mail : nicolas_agius@yahoo.fr                                         *
 *                                                                         *
 ***************************************************************************/
package ecamm;

/**
 * Titre :  EtabDATA [ECaMM]
 * Description : Classe de donnes Etablissement
 * Copyright : GPL v2.0 - 2005
 * @author : Nicolas AGIUS
 * @version 1.0
 */


import java.sql.SQLException;
import java.sql.ResultSet;

public class EtabDATA extends Data
{
    private String m_sNom;
    private String m_sRNE;
    private String m_sSlis;
    private CommuneDATA m_dCommune;

    public EtabDATA()
    {
        //initialisation  vide
        p_iID=NONE;
        m_sNom="";
        m_sRNE="";
        m_sSlis="";
        m_dCommune=new CommuneDATA();
    }

    public EtabDATA(ResultSet rs) throws SQLException
    {
        //initialisation avec les donnes du resultset
        p_iID=rs.getInt("ET_ID");
        m_sNom=rs.getString("ET_NOM");
        m_sRNE=rs.getString("ET_RNE");
        m_sSlis=rs.getString("ET_SLIS");
	m_dCommune=new CommuneDATA(rs);
    }

    public String getNom()
    {
        return m_sNom;
    }

    public CommuneDATA getCommune()
    {
        return m_dCommune;
    }

    public String getRNE()
    {
        return m_sRNE;
    }

    public String getSlis()
    {
        return m_sSlis;
    }

    public String getFiche()
    {
	return new String(    "Nom :   \t" + m_sNom
			  + "\nCode RNE :\t" + m_sRNE
			  + "\nNom du SLIS :\t" + m_sSlis
			  + "\nCommune :\t" + m_dCommune
			  + "\nCirconscription: " + m_dCommune.getCirco());
    }

    public String toString()
    {
        return m_sNom + ", " + m_dCommune;
    }
}
