/***************************************************************************
 *                                                                         *
 *   Copyright (C) 2005  Nicolas AGIUS                                     *
 *                                                                         *
 *   This file is part of ECaMM.                                           *
 *                                                                         *
 *   ECaMM is free software; you can redistribute it and/or modify it      *
 *   under the terms of the GNU General Public License as published by     *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 *                                                                         *
 *   ECaMM is distributed in the hope that it will be useful, but          *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston,                *
 *    MA  02111-1307, USA.                                                 *
 *                                                                         *
 *   For more information about these matters, see the file named COPYING. *
 *                                                                         *
 *   Mail : nicolas_agius@yahoo.fr                                         *
 *                                                                         *
 ***************************************************************************/
package ecamm;

/**
 * Titre :  Main [ECaMM]
 * Description : Classe principale
 * Copyright : GPL v2.0 - 2005~2006
 * @author : Nicolas AGIUS
 * @version 1.2
 */

import javax.swing.JOptionPane;
import java.awt.Frame;

// TODO:
// -  Arranger focus-traversal-cycle pour rechercherDemandeIHM
// ???? focus traversal ?????????????
// - voir dplacement du bas IHM dans CreerIHM -> bug Swing

public class Main
{

    //Variable globale : porte de type package
    static ConfigurationCTL cf;

    public static void main(String[] argv)
    {
       String password;

        //affichage du SplashSreen
        Splash sp=new Splash(new Frame(),"splash.png");

        //creation du ConfigurationCTL global
        cf=new ConfigurationCTL(argv, sp);
	if(cf.debug()) System.out.println("Configuration ok...");

        //configuration initiale
        if(cf.isItNewConfig())
        {
            sp.setVisible(false);

            //pop up de configuration pour le 1er lancement
	    if(cf.debug()) System.out.println("First launch...");
            String rep=JOptionPane.showInputDialog(null,"Nom du lien ODBC :","Premier dmarrage",JOptionPane.QUESTION_MESSAGE);
            if(rep==null) System.exit(0);   //si cancel
	    cf.setOdbcName(rep);

            sp.setVisible(true);
        }

        if(cf.debug()) System.out.println("Openning DB connection...");
        while(!cf.loadDbDriver())
        {
            //pop up de configuration si erreur de connection base
	    if(cf.debug()) System.out.println("Failed ! Re-asking DB name...");
            String rep=JOptionPane.showInputDialog("Nom du lien ODBC :",cf.getOdbcName());
            if(rep==null) System.exit(0);   //si cancel
	    cf.setOdbcName(rep);

            sp.setVisible(true);
        }


        //affichage du login
        if(cf.isItNewConfig() || cf.isShowLogin())
        {
	    sp.setVisible(false);

	    if(cf.debug()) System.out.println("Show login popup...");
            password=ConfigurationIHM.showLogin();
            cf.save();

	    sp.setVisible(true);
        }
        else    //login et passwd enregistr
        {
            password=cf.getPassword();
        }

        //vrification du mot de passe
	if(cf.debug()) System.out.println("Checking password...");
        while(!cf.checkPassword(password))
        {
	    sp.setVisible(false);

	    if(cf.debug()) System.out.println("Failed ! Re-asking login...");
            password=ConfigurationIHM.showLogin();
            cf.save();

	    sp.setVisible(true);
        }

	if(cf.debug()) System.out.println("Creating GUI...");
        VisuIHM f=new VisuIHM();
	if(cf.debug()) System.out.println("Starting program...");
        f.setVisible(true);

        //arret du splash
        sp.dispose();
    }
}
